import 'package:firebase_for_all/models/core_for_all.dart';
import 'package:get/get.dart';

import '../firebase/firestore/bridge.dart';
import '../firebase/firestore/windows.dart';
import '../firebase/storage/models.dart';
import '../firebase/storage/windows.dart';
import '../functions.dart';

class FirebaseControlPanel extends GetxController {
  String? name;
  bool firestoreStatus;
  bool storageStatus;
  bool authStatus;
  dynamic options;
  FirestoreItem? _firestore;
  FirebaseStorageItem? _storage;
  //FirebaseFunctions? _functions;
  FirebaseControlPanel(
      {required this.firestoreStatus,
      required this.storageStatus,
      required this.authStatus,
      required dynamic options,
      this.name});

  Future<void> initialize() async {
    await FirebaseCoreForAll.initialize();
    if (!isValid() && firestoreStatus) {
      await initFirestoreWindows();
    }
    if (!isValid() && storageStatus) {
      await initStorageWindows();
    }
    if (firestoreStatus) {
      _firestore = FirestoreItem();
    }
    if (storageStatus) {
      _storage = FirebaseStorageItem();
    }
  }

  FirestoreItem? get firestore => _firestore;
  FirebaseStorageItem? get storage => _storage;
  //FirebaseFunctions? get functions => _functions;

}
