import 'package:firebase_core/firebase_core.dart';
import 'package:get/get.dart';
import 'package:firebase_core_desktop/firebase_core_desktop.dart'
    as firebase_core_desktop;
import 'package:firebase_auth_desktop/firebase_auth_desktop.dart'
    as firebase_auth_desktop;

import '../controller/firebase_control_panel.dart';
import '../functions.dart';

class FirebaseCoreForAll {
  static Future<void> initialize() async {
    if (isDesktop()) {
      firebase_core_desktop.FirebaseCore.registerWith();
      if (Get.find<FirebaseControlPanel>().authStatus) {
        firebase_auth_desktop.FirebaseAuthDesktop.registerWith();
      }
    }
    await Firebase.initializeApp(
        name: Get.find<FirebaseControlPanel>().name,
        options: Get.find<FirebaseControlPanel>().options);
  }
}
